/*!
 * XMG365
*/

Ext.ns('Ext.ux');
Ext.ux.ImageCrop = Ext.extend(Ext.Component, {
  quadratic: false,
  minWidth: 20,
  minHeight: 20,
  preserveRatio: true,
  initCrop: {
    x: -1,
    y: -1,
    h: 99999,
    w: 99999
  },
  cropData: {
    x: 0,
    y: 0,
    height: 0,
    width:0
  },
  initComponent: function() {
    this.preserveRatio = this.quadratic || this.preserveRatio;
    Ext.ux.ImageCrop.superclass.initComponent.call(this);
  },
  onRender : function(ct, position){
    var c = {};
    if(this.quadratic) {
      c.height = c.width = Math.min(this.initialWidth, this.initialHeight);
      this.maxWidth = this.maxHeight = c.height;
    }
    else {
      c.height = this.initialHeight;
      c.width = this.initialWidth;
      this.maxWidth = this.maxHeight = 10000;
    }
    this.cropData.height = c.height;
    this.cropData.width = c.width;
    Ext.ux.ImageCrop.superclass.onRender.call(this, ct, position);
    this.el.setStyle({
      position: 'relative',
      'background-color': '#777'
    }).setSize(this.initialWidth,this.initialHeight);
    var initCrop = this.initCrop;
    initCrop.x = Math.max(initCrop.x, 0);
    initCrop.y = Math.max(initCrop.y, 0);
    if (initCrop.w < 1) initCrop.w = 99999;
    if (initCrop.h < 1) initCrop.h = 99999;
    initCrop.w = Math.min(initCrop.w, c.width-initCrop.x);
    initCrop.h = Math.min(initCrop.h, c.height-initCrop.y);
    initCrop.w = Math.max(initCrop.w, this.minWidth);
    initCrop.h = Math.max(initCrop.h, this.minHeight);
    this.imageUrl = encodeURI(this.imageUrl);
    this.cropWrapper = this.el.insertFirst().setSize(this.initialWidth,this.initialHeight);
    this.cropWrapped = this.cropWrapper.insertFirst().setSize(initCrop.w, initCrop.h).setStyle({left: initCrop.x, top: initCrop.y});
    this.cropWrapped.insertFirst({tag: "img", src: Ext.BLANK_IMAGE_URL, width: c.width, height: c.height});
    this.cropBgBox = this.el.insertFirst().setStyle({
      background: 'url('+this.imageUrl+') no-repeat left top',
      position: 'absolute',
      left: 0,
      top: 0
    }).setSize(this.initialWidth,this.initialHeight).setOpacity(0.5);
    this.initWrapper();
  },
  getCropData: function() {
    return this.cropData;
  },
  initWrapper: function() {
    var parentBox = this;
    var cropBgBox = this.cropBgBox;
    var imageUrl = this.imageUrl;
    var result = this.cropData;
    var wrapped = new Ext.Resizable(this.cropWrapped, {
      wrap: true,
      pinned: true,
      minWidth: this.minWidth,
      minHeight: this.minHeight,
      maxWidth: this.maxWidth,
      maxHeight: this.maxHeight,
      draggable:true,
      preserveRatio: this.preserveRatio,
      handles: 'all',
      constrainTo: this.cropWrapper,
      listeners: {
        'resize': function (box, w, h) {
          box.imageOffset = [box.el.getBox().x - cropBgBox.getX(), box.el.getBox().y - cropBgBox.getY()];
          result.width = w;
          result.height = h;
          result.x = box.imageOffset[0];
          result.y = box.imageOffset[1];
          box.el.setStyle({
            'background-image':'url('+imageUrl+')',
            'background-position':(-box.imageOffset[0])+'px '+(-box.imageOffset[1])+'px',
            'background-repeat':'no-repeat'
          });
//          parentBox.cropBgBox.setOpacity(0.5);
          if(parentBox.fireEvent('change', parentBox, result) === false){
            return parentBox;
          }
//          console.warn('resize');
        },
        'beforeresize': function () {
//          this.getEl().setStyle({background:'transparent'});
//          parentBox.cropBgBox.setOpacity(1);

        }
      },
      dynamic:true
    });
    wrapped.getEl().setStyle({background:'url('+imageUrl+')','background-repeat':'no-repeat','background-position':'-'+this.initCrop.x+'px -'+this.initCrop.y+'px'});
    setTimeout(function(){wrapped.dd.resetConstraints();},500);
    wrapped.imageOffset = [0,0];
    wrapped.dd.endDrag = function(){
      if (wrapped.getEl().getBox().x - cropBgBox.getX() > parentBox.initialWidth)
      {
//        console.warn(wrapped.getEl().getBox().x);
        wrapped.getEl().setLeft(cropBgBox.getX());
      }
      if ( wrapped.getEl().getBox().y - cropBgBox.getY() > parentBox.initialHeight)
      {
//          console.warn(wrapped.getEl().getBox().y);
          wrapped.getEl().setTop(cropBgBox.getY());
      }

      wrapped.imageOffset = [wrapped.getEl().getBox().x - cropBgBox.getX(), wrapped.getEl().getBox().y - cropBgBox.getY()];
      result.x = wrapped.imageOffset[0];
      result.y = wrapped.imageOffset[1];
      wrapped.getEl().setStyle({
        'background-image':'url('+imageUrl+')',
        'background-position':(-wrapped.imageOffset[0])+'px '+(-wrapped.imageOffset[1])+'px',
        'background-repeat':'no-repeat'
      });
      if(parentBox.fireEvent('change', parentBox, result) === false){
        return parentBox;
      }
    };
    wrapped.dd.startDrag = function(e){
      wrapped.getEl().setStyle({
//        'background':'transparent'
      });
    };
    wrapped.dd.onDrag = function(){
      wrapped.imageOffset = [wrapped.getEl().getBox().x - cropBgBox.getX(), wrapped.getEl().getBox().y - cropBgBox.getY()];
      result.x = wrapped.imageOffset[0];
      result.y = wrapped.imageOffset[1];
      wrapped.getEl().setStyle({
        'background-image':'url('+imageUrl+')',
        'background-position':(-wrapped.imageOffset[0])+'px '+(-wrapped.imageOffset[1])+'px',
        'background-repeat':'no-repeat'
      });
    };
  }
});
